{    var   : }
{ FC }
Unit MNB2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNB2R(N :Integer; var X :Array of Real;
                var S :Array of Real; var XX :Array of Real;
                var A :Real; var B :Real; EPS :Real; var C :Real;
                var FC :Real; MAXK :Integer; FUN :Proc_F1_MN;
                var IERR :Integer);

implementation

procedure MNB2R(N :Integer; var X :Array of Real;
                var S :Array of Real; var XX :Array of Real;
                var A :Real; var B :Real; EPS :Real; var C :Real;
                var FC :Real; MAXK :Integer; FUN :Proc_F1_MN;
                var IERR :Integer);
var
I,K :Integer;
DELK,FA,FB,FE,FIMN,FIMX,FXLA,FXMU,XLA,XMU :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120;
begin
K := 0;
IERR := 0;
C := (A + B)/2.0;
for I:=1 to N do
 begin
  XX[I-1] := X[I-1] + A*S[I-1];
_10:
 end;
FUN(XX,FA,FE);
for I:=1 to N do
 begin
  XX[I-1] := X[I-1] + C*S[I-1];
_20:
 end;
FUN(XX,FC,FE);
for I:=1 to N do
 begin
  XX[I-1] := X[I-1] + B*S[I-1];
_30:
 end;
FUN(XX,FB,FE);
_40:
DELK := B - A;
if ( DELK - EPS ) < 0
 then goto _120
 else if ( DELK - EPS ) > 0
       then goto _50
       else goto _50;
_50:
XMU := (A + C)/2.0;
XLA := (C + B)/2.0;
for I:=1 to N do
 begin
  XX[I-1] := X[I-1] + XMU*S[I-1];
_60:
 end;
FUN(XX,FXMU,FE);
for I:=1 to N do
 begin
  XX[I-1] := X[I-1] + XLA*S[I-1];
_70:
 end;
FUN(XX,FXLA,FE);
FIMN := EMin1(EMin1(EMin1(EMin1(FA,FXMU),FC),FXLA),FB);
FIMX := EMax1(EMax1(EMax1(EMax1(FA,FXMU),FC),FXLA),FB);
if ( FIMX - FIMN <=  EPS*0.01 ) 
 then goto _110;
if ( FA =  FIMN ) or (  FXMU =  FIMN ) 
 then goto _80;
if ( FB =  FIMN ) or (  FXLA =  FIMN ) 
 then goto _90;
A := XMU;
FA := FXMU;
B := XLA;
FB := FXLA;
goto _100;
_80:
B := C;
FB := FC;
C := XMU;
FC := FXMU;
goto _100;
_90:
A := C;
FA := FC;
C := XLA;
FC := FXLA;
_100:
K := K + 1;
if ( K <  MAXK ) 
 then goto _40;
IERR := 65;
goto _120;
_110:
IERR := 66;
_120:
end;

end.
